//Shopping and Stock Management System
//CS 101 Course Project Autumn 2011
//Prof : Dr.Deepak B Phatak
//Lab-Batch : 551
//** Spaces are not handled by the program correctly **


#include <iostream>
#include <cstring>
#include <cstdlib>
#include <stdio.h>
#include <fstream>
#include <cassert>

using namespace std;

struct product														//Defining structure of product
{
	char id[6];
	char mcat[15];      //main category
	char brand[15];
	char desc[30];      //description
	int qty;
	float mrp;
};

struct sale
{
	char name[20];
	char phoneno[20];
	char cardno[20];
	char icode[6];
	char brand[10];
	char desc[40];
	float price;
	char dateandtime[25];
};

struct employee													//Defining structure of employee
{	
	int dept;									
	char id[20];
	char pwd[20];
	char fname[20];
	char lname[20];
	
};

struct order														//Defining structure of order
{
	int no;
	char icode[6];
	int qty;
	char company[30];
	char timestamp[25];
	char status[12];
};

struct run                                                      //run and run2 are declared for easier access of IDs                         
{
	char storeid[6];
};

 
struct run2
{
	char inputid[6];
};


struct employee e[100];
struct product p[100];
struct order o[100];
struct run RuntimeStoreID[50];
struct run2 RuntimeInputID[50];
struct sale s[100];

long long totalrevenue;

int no_empl,no_prod,no_ord,len;
int no_sales;
int j,pos,t=-1;

float discountrate,margin;										//Declaring necessary variables
float RuntimePrice,DiscountedPrice,discount;

bool a;

string option;
string choice;
string prod_id;

int ValidateItemCode(string prod_code);
void displaymanaging();
void displaysales();
void displayinventory();
void LoadOrderData();
void set_discount();
void change_password();
void add_product();
void del_product();
void search_product();
void mod_product();
void ord_product();
void displayOrders();
void set_ord_status();
void viewStock();
void LoadProductData();                                        
void LoadSalesData();
void DisplayCategories();
void setDisplay();
void DisplayItems(string s);
void InputProductID();
void CustomerDetails();
void WelcomeScreen();
void LoadDiscount();

bool ValidateIntegerInput(char s[10])          //----Function to check a valid integer input
{ bool checked;
	for(int i=0;s[i]!='\0';i++)
	{checked=true;
	if(s[i]<'0'||s[i]>'9'){checked=false;break;}
	}
return checked;
}

bool ValidateFloatInput(char s[10])           //-----Function to check a valid float input
{ bool checked;int k=0;
	for(int i=0;s[i]!='\0';i++)
	{
		if((s[i]>='0'&&s[i]<='9')||s[i]=='.')
		{
			if(s[i]=='.'){k++;}
			{if(k==1||k==0)	checked=true;
			else {checked=false;}}
		}
		else{checked=false;break;}
	}
return checked;
}





void LoadSalesData()       //---------------Function to read Sales data and store in defined array of structures
{
	int i=0;
	FILE *fp;
	fp=fopen("Sales.txt","r");  	
	while(!feof(fp))
	{
	                        //structue of sales are initiallised
		fscanf(fp,"%s %s %s %s %s %s %f %s",s[i].name,s[i].phoneno,s[i].cardno,s[i].icode,s[i].brand,s[i].desc,&s[i].price,s[i].dateandtime);
		 
		totalrevenue+=s[i].price;			
		i++;
	}
	
	no_sales =i-1 ;
	fclose(fp);
}

void LoadProductData()		//-------------------Function to read Product data and store in defined array of structures
{
	int i=0;
	FILE *fp1;
	fp1=fopen("Product.txt","r");  	
	while(!feof(fp1))
	{	
		fscanf(fp1,"%s %s %s %s %d %f",p[i].id,p[i].mcat,p[i].brand,p[i].desc,&p[i].qty,&p[i].mrp);		//structue of product are initiallised 
		i++;
	
	}
	

	no_prod =i-1;
	fclose(fp1);
}

void DisplayCategories()    //----------------------displays catagories to customers
{	
	cout<<"\nChoose a Category:\n";       
	cout<<"\n1 : Laptops";
	cout<<"\n2 : Cameras";
	cout<<"\n3 : Television";
	cout<<"\n4 : Mobile";
	cout<<"\n5 : Watch";
	cout<<"\n6 : Glasses";
	cout<<"\n7 : FootWear";
	cout<<"\n8 : Exit";
	checkpoint8:	
	cout<<"\nEnter your option : ";
	cin>>choice;                                //choice entered by the customer
	
	{
		if(choice=="1")			    //checks the choice entered by the customer
		{
			DisplayItems("laptop");
		}   
		
		else if(choice=="2")
		{
			DisplayItems("camera");
		}
	
		else if(choice=="3")
		{
			DisplayItems("television");
		}
		
		else if(choice=="4")
		{
			DisplayItems("mobile");
		}

		else if(choice=="5")
		{
			DisplayItems("watch");
		}
	
		else if(choice=="6")
		{
			DisplayItems("glasses");
		}
	
		else if(choice=="7")
		{
			DisplayItems("shoes");
		}

		else if(choice=="8")
		{
			WelcomeScreen();
		}

		else
		{
			cout<<"Enter Correct option\n";
			goto checkpoint8;
		}
	}
}


void DisplayItems(string s)             //-------------------function to display items available for the category choosen by the customer
{    
	j=0;
	cout<<"\n\nProduct ID\tBrand\t\t\t\tDescription \tPrice \n\n";	   
	for(int i=0;i<no_prod;i++)
	{
		if(p[i].mcat==s)
		{	
			if(p[i].qty!=0)
			{                   
				printf("%s    %10s %40s   %.2f \n",p[i].id,p[i].brand,p[i].desc,p[i].mrp);
			}  
		
			strcpy(RuntimeStoreID[j].storeid,p[i].id);
			j++;
		}
	}
	InputProductID();
}


void InputProductID()         //--------------------------------it takes input of the id of the product customer wants to buy
{	
	string optiontobuy;
ch:
	cout<<"\nPress 1 to continue OR 2 to go back :";        //checks if he/she surely wants to buy any of the item displayed above
	cin>>optiontobuy;

	if(optiontobuy=="1")
	{
		goto check;
	}

	else if(optiontobuy=="2")
	{
		DisplayCategories();
	}

	else goto ch;
		
check:
	cout<<"\nEnter Product ID :";
	cin>>prod_id;
	bool a=false;
	string confirmation1,confirmation2;
	
	for(int m=0;m<j;m++)                       //loop to check the input ID and the one which is in database
	{
		if(prod_id==RuntimeStoreID[m].storeid)
		{
			for(int k=0;k<no_prod;k++)
			{
				if(prod_id==p[k].id)
				{
					pos=k;
					a=true;
					break;
				}
			}	
		}
	}						
			
	if (a==true)				//if matches
	{			
		cout<<"\n Confirm your purchase : \n";
		printf("%10s %40s   %.2f\n",p[pos].brand,p[pos].desc,p[pos].mrp);     
		cout<<"Are you sure you want to buy the above item\n";
	x0:		
		cout<<"Y      or       N : ";
		cin>>confirmation1;                                     // confirmation : if customer surely wants to buy the selected item
		if (confirmation1=="y"||confirmation1=="Y")
		{    
			t++;
			strcpy(RuntimeInputID[t].inputid,p[pos].id);
			RuntimePrice +=p[pos].mrp;
	x:
			cout<<"Do You want to buy something more?\n";
			cout<<"Y   or    N : ";
			cin>>confirmation2;                             //confirmation : if he wants to buy something else
			if(confirmation2=="y"||confirmation2=="Y")
			{
				DisplayCategories();
			}		
				
			else if(confirmation2=="n"||confirmation2=="N")
			{
				if(RuntimePrice!=0)
				{
					CustomerDetails();       
				}
		
				else WelcomeScreen();
			}
				
			else goto x;
		}
			
		else if(confirmation1=="n"||confirmation1=="N")
		{
			goto x;
		}
	
		else goto x0;
	}
		
	if(a==false)
	{
		cout<<"Enter Correct Product ID!!!\n";
		goto check;
	}		
			
	
}
	
void CustomerDetails()        //--------------------------------takes input of the customer details after he had chosen the products
{		
		system("clear");
		int k=no_sales,j=0,chk=0;
		string lastchoice;
		char cust_name[20],cust_phoneno[20],cust_cardno[20],cust_cardpinno[20];

		LoadSalesData();                //Sales are loaded
		
		cout<<"\n\t\tYour Purchase Summary\n\n";                  //displays purchase summary
		for(int a=0;a<=t;a++)
		{
			for(int y=0;y<no_prod;y++)
			{
				if(p[y].id==(string)RuntimeInputID[a].inputid)
				{
					printf("%10s %40s       %.2f\n",p[y].brand,p[y].desc,p[y].mrp);
				}
			}
		}
				
		cout<<"\n\t\tYour purchase Amount is: Rs. "<<RuntimePrice<<endl;        //shows net price before discount, discount and after discount
		if (RuntimePrice>=margin) 
		{	
			discount = RuntimePrice*discountrate/100;
			DiscountedPrice=RuntimePrice-discount;
			cout<<"\t\tDiscount               : Rs. "<<discount<<endl;
			cout<<"\t\tDiscountedPrice        : Rs. "<<DiscountedPrice<<endl;
		}

		else
		{
			DiscountedPrice=RuntimePrice;discount=0;
		}
 					
		cout<<"\n\nPlease enter your Personal Details\n";             //customer details are asked to be filled 
		cout<<"----------------------------------\n";
		FILE*fp2;
		cout<<"\n\nPlease Enter your Name (use_ for spaces) : ";
		cin>>cust_name;
		cout<<"\n\nPlease Enter your Contact no. :  ";
		checkpoint2:cin>>cust_phoneno;

bool checkresultphone;							//checks if the number is of 10 digits or not
		
		for(int i=0;cust_phoneno[i]!='\0';i++)
		{	
			checkresultphone=true;
			if((cust_phoneno[i])<'0' || (cust_phoneno[i])>'9')
			{
				checkresultphone=false;
				break;
			}     
		}                               
		   
		len=strlen(cust_phoneno);   
		
		if(len>=15 ||len<=9|| checkresultphone==false)
		{
			if(chk<=1)  
			{
				cout<<"\nPlease Enter a Valid Contact no.:  ";   
				chk++;
				goto checkpoint2;   
			}
      
			else
			{
				cout<<"\nSorry !";WelcomeScreen();
			}	
		}  
				
		cout<<"Please Enter your credit card number :  ";		//checks the validation of the 16 digit credit card no.
	
	checkpoint3:
		cin>>cust_cardno;
		bool checkresultcard;
		for(int i=0;cust_cardno[i]!='\0';i++)
		{	
			checkresultcard=true;
			if((cust_cardno[i])<'0' || (cust_cardno[i])>'9')                     
			{
				checkresultcard=false;
				break;
			}     
		}                               
		  
		len=strlen(cust_cardno);   
		if(len!=16 || checkresultcard==false)
		{
			if(chk<=1)  
			{
				cout<<"\nPlease Enter 16 digit Valid Credit Card no.:  ";   
				chk++;
				goto checkpoint3;   
			}      
		
			else
			{
				cout<<"\nSorry !";
				WelcomeScreen();
			}
		}


	cout<<"\nPlease Enter your credit card PIN number :  ";		//checks the validation of the 4 digit credit card PIN no.
	
	checkpointpin:
		cin>>cust_cardpinno;
		bool checkresultpinno;
		for(int i=0;cust_cardpinno[i]!='\0';i++)
		{	
			checkresultpinno=true;
			if((cust_cardpinno[i])<'0' || (cust_cardpinno[i])>'9')                     
			{
				checkresultpinno=false;
				break;
			}     
		}                               
		  
		len=strlen(cust_cardpinno);   
		if(len!=4 || checkresultpinno==false)
		{
			if(chk<=1)  
			{
				cout<<"\nPlease Enter 4 digit Valid Credit Card PIN no.:  ";   
				chk++;
				goto checkpointpin;   
			}      
		
			else
			{
				cout<<"\nSorry !";
				WelcomeScreen();
			}
		}


		else
		{
			fp2=fopen("Sales.txt","w");  	              //prints the details of the order which has been placed in "sales.txt"
								      //also quantities in "product.txt" is modified	
			int u=0;
			time_t rawtime;
  			struct tm * timeinfo;
	
  			time ( &rawtime );
  			timeinfo = localtime ( &rawtime );
			for(int m=k;m<=k+t;m++)
			{
				strcpy(s[m].name,cust_name);
				strcpy(s[m].phoneno,cust_phoneno);		
				strcpy(s[m].cardno,cust_cardno); 
				
				strcpy(s[m].icode,RuntimeInputID[u].inputid);
		
				for(int l=0;l<no_prod;l++)
				{
					if((string)RuntimeInputID[u].inputid==p[l].id)
					{
						pos=l;
						break;
					}
				}

				p[pos].qty--;
				strcpy(s[m].brand,p[pos].brand);
				strcpy(s[m].desc,p[pos].desc);
				if (RuntimePrice>=margin)		//checks if the total amount purchased exceeds the set margin price for discount
				{
					s[m].price=p[pos].mrp-(p[pos].mrp*discountrate/100);
				}
		
				else
				{
		 			s[m].price=p[pos].mrp;
				}
			
				strftime (s[m].dateandtime,25,"%m/%d/%Y:%H:%M:%S",timeinfo);
				u++;
			}
			
			no_sales=no_sales+t+1;
        
			while(j<no_sales)
			{	
				fprintf(fp2,"%15s %15s %16s  %5s %10s %30s  %.2f %25s\n",s[j].name,s[j].phoneno,s[j].cardno,s[j].icode,s[j].brand,s[j].desc,s[j].price,s[j].dateandtime);
		
			j++;
			}
	 
			FILE *fp1;
			fp1=fopen("Product.txt","w+");	          //here the modification in "product.txt" is done
			j=0;	
			while(j<no_prod)
			{
				fprintf(fp1,"%s %s %s %s %d %.2f \n",p[j].id,p[j].mcat,p[j].brand,p[j].desc,p[j].qty,p[j].mrp);
				j++;
			}
	
			fclose(fp1);
			fclose(fp2);
			cout<<"\n\tDelivery section will contact you for address details\n";
			cout<<"\n\tYour good(s) will be delivered at an earliest date possible\n";
			cout<<"\t\t\t\tThank You\n";
		}

	checkpoint4:   
		
		cout<<"\n1 : MainMenu\t\t\t2 : Exit\n";
		cin>>lastchoice;
		if(lastchoice=="1")WelcomeScreen();
		if(lastchoice=="2")exit(0);    
		if(lastchoice!="1" || lastchoice!="2")
		{   
			cout<<"\nInvalid Input\n";   
			goto checkpoint4;
		}   
}




				//*********************************************************************************************//
				//*********************************************************************************************//




void LoadEmployeeData()		//-------------------------------Function to read Employee data and store in defined array of structures
{
	int i=0;
	FILE *fp;
	fp=fopen("Employee.bin","rb");  	
	while(!feof(fp))
	{
		fscanf(fp,"%d %s %s %s %s",&e[i].dept,e[i].id,e[i].pwd,e[i].fname,e[i].lname);			
		i++;
	}
	
	no_empl =i-1 ;
	fclose(fp);
}


string eid;

int department;
void password_chk()		//--------------------------------Function to check whether the entered ID and password are valid
{	
		
	int chk=0;
	string epwd ;
	a=false;

checkpoint1:

	cout<< "\nLogin ID : " ;		//this is the login point
	cin >> eid ;
	cout<< "\nPassword : " ;
	cin >> epwd ;
	
	for(int i=0;i<no_empl;i++)		//verification of the id and password entered
	{
		if((eid==e[i].id)&&(epwd==e[i].pwd))			
		{
			a=true;
			pos=i;
			break;
		}
	}
		
	if (a==true)
	{
		cout <<"\nLogin Successful\n"<<endl;
		cout <<"\t\tWelcome "<<e[pos].fname<<" "<<e[pos].lname<<"  ::  ";

			//checks the dept. of the logged in employee and according to that it displays the function he/she can use

		if(e[pos].dept==1)
		{
			department=1;cout<<"Managing Dept"<<endl;displaymanaging();
		}

		if(e[pos].dept==2)
		{
			department=2;cout<<"Sales Dept"<<endl;displaysales();
		}

		if(e[pos].dept==3)
		{
			department=3;cout<<"Inventory Dept"<<endl;displayinventory();
		}

	}

	else						 
	{
		cout<<"\nAuthentication Failed"<<endl;
		chk++;
		if(chk<=2)
		{
			goto checkpoint1;
		}

		else
		{
			 WelcomeScreen();
		}			
	}
}

void setDisplay()            //-----------------------displays functions according to the dept. of the logged employee
{
	if (department==1)
	{
		displaymanaging();
	}
	if (department==2)
	{
		displaysales();
	}
	if (department==3)
	{
		displayinventory();
	}
}

void displaymanaging()		//--------------------Function to display various options that a managing dept employee can use
{
checkpoint2:
	
	cout<<endl;
	cout<<"\t1 : Reset your Password"<<endl;
	cout<<"\t2 : Search Product"<<endl;
	cout<<"\t3 : Add a Product"<<endl;
	cout<<"\t4 : Modify Details of a product"<<endl;
	cout<<"\t5 : Delete a Product"<<endl;
	cout<<"\t6 : LogOut"<<endl;
	cout<<"\nEnter your option : ";
	cin>>option;
	
					//Assinging specific functions to a specific option
	
		
		if(option=="1")
		{
			change_password();
		}

		else if(option=="2")
		{
			search_product();
		}
		
		else if(option=="3")
		{
			add_product();
		}

		else if(option=="4")
		{
			mod_product();
		}
		
		else if(option=="5")
		{
			del_product();
		}

		else if(option=="6")
		{
			WelcomeScreen();
		}

		else
		{
			cout<<"\nPlease enter correct option\n";
				goto checkpoint2;
		}
	
}

	
void displaysales()                  //--------------------Function to display various options that a sales dept. employee can use
{
checkpoint2:
	
	cout<<endl;
	cout<<"\t1 : Reset your Password"<<endl;
	cout<<"\t2 : Search a Product"<<endl;
	cout<<"\t3 : View Sales History"<<endl;
	cout<<"\t4 : Set DiscountRate and MarginPrice"<<endl;
	cout<<"\t5 : LogOut"<<endl;
	cout<<"\nEnter your option : ";
	cin>>option;
	
						//Assinging specific functions to a specific option

	{
		if(option=="1")
		{
			change_password();
		}

		else if(option=="2")
		{
			search_product();
		}

		else if(option=="3")
		{
			totalrevenue=0;
			LoadSalesData();
			system("gedit Sales.txt");
			system("clear");
			cout<<"\nPlease note that Sales History has been opened with default text editor\n";
			cout<<"\n\tTotal Revenue : Rs. "<<totalrevenue<<endl;
			displaysales();
		}
		
		else if(option=="4")
		{
			set_discount();
		}
	
		else if(option=="5") 
		{
			WelcomeScreen();
		}
		
		else
		{
			cout<<"\nPlease enter correct option\n";
			goto checkpoint2;
		}
	}
}

void displayinventory()			//--------------------Function to display various options that a inventory dept. employee can use
{	
checkpoint2:

	cout<<endl;
	cout<<"\t1 : Reset your Password"<<endl;
	cout<<"\t2 : Search Product"<<endl;
	cout<<"\t3 : Order a product from a company"<<endl;
	cout<<"\t4 : View Orders"<<endl;
	cout<<"\t5 : Set Order Status"<<endl;
	cout<<"\t6 : View Stock Details"<<endl;
	cout<<"\t7 : LogOut"<<endl;
	cout<<"\nEnter your option : ";
	cin>>option;
	
					//Assinging specific functions to a specific option

	{
		if(option=="1")
		{
			change_password();
		}

		else if(option=="2")
		{
			search_product();
		}

		else if(option=="3")
		{
			ord_product();
		}

		else if(option=="4")
		{
			displayOrders();
		}

		else if(option=="5")
		{
			set_ord_status();
		}
		else if(option=="6")
		{
			viewStock();
		}
	
		else if(option=="7")
		{
			WelcomeScreen();
		}
		
		else
		{
			cout<<"\nPlease enter correct option\n";
			goto checkpoint2;
                }
	}
}

void change_password()			//-------------------------------------Function to reset the password of employee
{
	FILE *fp;
	int count1=0,position=-1,chk=0;
	string oldpwd,id;
	char newpwd1[20],newpwd2[20];
	
checkpoint3:
	
	cout<< "\nEnter your existing Password : ";	//rechecking the existing password
	cin >> oldpwd;
       
	for(count1=0;count1<no_empl;count1++)
	{									
		if((eid==e[count1].id)&&(oldpwd==e[count1].pwd))			
		{
			position=count1 ;
		}
         
	}
	
	if(position<0 && chk<=1)	
	{
		cout<< "Incorrect Entry.Enter again.\n\n" ;
		chk++ ;
		goto checkpoint3;
	}
	if(chk>1)
	{
		cout<< "\nWrong Information entered thrice.\n" ;		
		WelcomeScreen();
	}
	

checkpoint4:					//changing the password and confirming the password through 2 inputs
	
	cout<< "\nEnter your new password :  ";
	cin >> newpwd1;
	cout<< "\nEnter the new password again : "; 
	cin >> newpwd2;

	if(strcmp(newpwd1,newpwd2)!=0)
	{
		cout<<"\n Passwords do not match...Please enter again.\n";
		goto checkpoint4;
	}

	else 
	{
		strcpy(e[position].pwd,newpwd1);
	}
      
	fp=fopen("Employee.bin","wb");
	int i=0;

	while(i<no_empl)
	{
		fprintf(fp,"%d %s %s %s %s \n",e[i].dept,e[i].id, e[i].pwd,e[i].fname,e[i].lname);
 		i++;
	}

	system("clear");
	cout<<"\n\nPassword successfully changed !\n\n";
	fclose(fp);
	password_chk();			//employee is taken to the login screen to login again 
}


void add_product()													//Function to add a product in product database
{
	system("clear");
	int g=no_prod;char newproductcode[10],newquantity[10],newprice[10];
	
	cout<<"\n\n\tEnter Product Code : ";
	cin>>newproductcode;
	if(ValidateItemCode((string)newproductcode)!=-1)	{cout<<"\nProduct already exists\n";setDisplay();}
	if(ValidateIntegerInput(newproductcode)==false)	{cout<<"\nData Invalid\n";setDisplay();}
	strcpy(p[g].id,newproductcode);
	cout<<"\n\t* Be sure that Product category already exists.\n\tIf not contact System Administrator *\n\t";
	cout<<"\n\tEnter Product Category :";	
	cin>>p[g].mcat;
	cout<<"\n\tEnter Product Brand :";
	cin>>p[g].brand;
	cout<<"\n\tEnter Product Description (use _ for space) :";
	cin>>p[g].desc;
	cout<<"\n\tEnter Product Quantity :";
	cin>>newquantity;
	
	if(ValidateIntegerInput(newquantity)==false)	 {cout<<"\nData Invalid\n";setDisplay();}
	int newqty=atoi(newquantity);
	if(newqty!=0){p[g].qty=newqty;}	else 	{cout<<"\nData Invalid\n";setDisplay();}
	cout<<"\n\tEnter Product MRP :";
	cin>>newprice;
	
	if(ValidateFloatInput(newprice)==false) 	{cout<<"\nData Invalid\n";setDisplay();}
	float newmrp=atof(newprice);
	if(newmrp!=0){p[g].mrp=newmrp;}	else 	{cout<<"\nData Invalid\n";setDisplay();}
	no_prod++;
	
	FILE *fp1;
	fp1=fopen("Product.txt","w+");	
	int j=0;	
	while(j<no_prod)
	{
		fprintf(fp1,"%s %s %s %s %d %.2f \n",p[j].id,p[j].mcat,p[j].brand,p[j].desc,p[j].qty,p[j].mrp);
		j++;
	}
	fclose(fp1);
	system("clear");	
	cout<<"\nProduct Successfully Added\n\n";
	displaymanaging();
	
}





void search_product()		//------------------------------Function to search a product in database
{
	string input;
	cout<<"\n\nEnter the Product Code :";
	cin>>input;

	if(ValidateItemCode(input)!=-1)		// checking that whether the product exist with the input code
	{	int pos=ValidateItemCode(input);
		system("clear");		
		cout<<"\n\t\tProduct Details";		// Displays details of the product
		cout<<"\n\n\tCategory           :  "<<p[pos].mcat;
		cout<<"\n\tBrand              :  "<<p[pos].brand;
		cout<<"\n\tDescription        :  "<<p[pos].desc;
		cout<<"\n\tQuantity Available :  "<<p[pos].qty;
		cout<<"\n\tM.R.P              :  "<<p[pos].mrp;
		cout<<endl<<endl;
		setDisplay();
	}
	else{system("clear");cout<<"\nProduct does not exist\n";setDisplay();}	
}

void mod_product()		//-------------------------------Function to modify details of an existing product
{
	char input[20],modproductcode[20],modqty[10],modmrp[10];
	system("clear");
	cout<<"\n\nEnter the Product Code :";
	cin>>input;
	if(ValidateItemCode((string)input)!=-1)		// checking that whether the product exist with the input code
	{
		int pos=ValidateItemCode(input);
		
		system("clear");		
		cout<<"\n\t\tProduct Details";		// Displays details of the product
		cout<<"\n\n\tCategory           :  "<<p[pos].mcat;
		cout<<"\n\tBrand              :  "<<p[pos].brand;
		cout<<"\n\tDescription        :  "<<p[pos].desc;
		cout<<"\n\tQuantity Available :  "<<p[pos].qty;
		cout<<"\n\tM.R.P              :  "<<p[pos].mrp;
		cout<<endl<<endl;
		
		cout<<"\n\n\tEnter new Product Code : ";	// modify details
		cin>>modproductcode;
		if(ValidateIntegerInput(modproductcode)==false){cout<<"\nData Invalid\n";setDisplay();}
		strcpy(p[pos].id,modproductcode);		
		cout<<"\n\tEnter new Product Category :";
		cin>>p[pos].mcat;
		cout<<"\n\tEnter new Product Brand :";
		cin>>p[pos].brand;
		cout<<"\n\tEnter new Product Description (use _ for space) :";
		cin>>p[pos].desc;
		cout<<"\n\tEnter new quantity :";
		cin>>modqty;
		if(ValidateIntegerInput(modqty)==false){cout<<"\nData Invalid\n";setDisplay();}
		int modifiedquantity=atoi(modqty);
		if(modifiedquantity!=0){p[pos].qty=modifiedquantity;} else {cout<<"\nData Invalid\n";setDisplay();}
		cout<<"\n\tEnter new Product MRP :";
		cin>>modmrp;
		if(ValidateFloatInput(modmrp)==false){cout<<"\nData Invalid\n";setDisplay();}
		float modifiedprice=atof(modmrp);
		if(modifiedprice!=0){p[pos].mrp=modifiedprice;}{cout<<"\nData Invalid\n";setDisplay();}

		FILE *fp1;
		fp1=fopen("Product.txt","w+");	
		int j=0;	
		while(j<no_prod)		// printing the details of the products in "Product.txt"
		{
			fprintf(fp1,"%s %s %s %s %d %.2f \n",p[j].id,p[j].mcat,p[j].brand,p[j].desc,p[j].qty,p[j].mrp);
			j++;
		}
		fclose(fp1);
		system("clear");		
		cout<<"\n\nData successfully updated\n\n";
		displaymanaging();
	}

	else
	{
		system("clear");
		cout<<"\nProduct does not exist\n";
		setDisplay();
	}	
}
		
void LoadOrderData()		//-----------------------Load the data of the ordered product from "order.txt" to the defined structures
{	int i=0;
	FILE *fp;
	fp=fopen("Order.txt","r");
	while(!feof(fp))
	{
		fscanf(fp,"%d %s %d %s %s %s",&o[i].no,o[i].icode,&o[i].qty,o[i].company,o[i].timestamp,o[i].status);			
		i++;
	}
	fclose(fp);
	no_ord =i-1 ;
}
	
void ord_product()		//------------------------Function to order a product from a company
{
	LoadOrderData();
	int j=0;
	string code;char ordqty[10];
	cout<<"\nFor Ordering a new product,please make sure that the product is in database\n";
	cout<<"\n\tEnter the Itemcode : ";
	cin>>code;
        if(ValidateItemCode(code)!=-1)		// checking that whether the product exist with the input code
	{	
		strcpy(o[no_ord].icode,p[ValidateItemCode(code)].id);
		cout<<"\n\tEnter Quantity : ";
		cin>>ordqty;
		if(ValidateIntegerInput(ordqty)==false){cout<<"\nData Invalid\n";setDisplay();}
		int orderedquantity=atoi(ordqty);
		if(orderedquantity!=0){o[no_ord].qty=orderedquantity;}else{cout<<"\nData Invalid\n";setDisplay();}
		cout<<"\n\tEnter Company (use _ for spaces) : ";
		cin>>o[no_ord].company;
		o[no_ord].no=o[no_ord-1].no+1;
		strcpy(o[no_ord].status,"NotReceived");
		time_t rawtime;
  		struct tm * timeinfo;
	
  		time ( &rawtime );
  		timeinfo = localtime ( &rawtime );
	
  		strftime (o[no_ord].timestamp,25,"%m/%d/%Y:%H:%M:%S",timeinfo);	//printing the time of placing the order
		no_ord++;
		FILE *fp1;
		fp1=fopen("Order.txt","w+");
		while(j<no_ord)
		{
			fprintf(fp1,"%3d %s %3d %30s %s %s \n",o[j].no,o[j].icode,o[j].qty,o[j].company,o[j].timestamp,o[j].status);
			j++;
		}

		cout<<"\nOrder has been placed with Order Number "<<o[no_ord-1].no<<endl;
		fclose(fp1);
		displayinventory();
	}

	else
	{
		cout<<"\nProduct does not exist\n";setDisplay();
	}
}

void displayOrders()		//----------------------Displays the placed order along with its status by opening the file "order.txt"
{
	system("clear");
	cout<<"\nPlease note that list of Orders have been opened with default text editor\n";
	system("gedit Order.txt");
	displayinventory();
}

void set_ord_status()		//-----------------------Set the status of order as recieved
{
	int pos2;string option1;
	int pos1=-1;
	char order[10];

	LoadOrderData();
	system("clear");
	cout<<"Enter Order Number :";
	cin>>order;
	int ord_number=atoi(order);
	for(int i=0;i<no_ord;i++)		//search for the order no.
	{	
		if(ord_number==o[i].no)
		{
			pos1=i;
			break;
		}
	}

	for (int i=0;i<no_prod;i++)
	{
		if(strcmp(o[pos1].icode,p[i].id)==0)
		{
			pos2=i;
			break;
		}
	}

	if (pos1==-1)		//check if the order exists
	{
		system("clear");
		cout<<"\nOrder does not exist\n";
		displayinventory();
	}
	else
	{
		x3:cout<<"\n Press 1 for Received OR 2 to GoBack : ";		//confirm to change the status of the order if not recieved
		cin>>option1;
		if(option1=="1")
		{
			if(strcmp(o[pos1].status,"NotReceived")==0)
			{
				strcpy(o[pos1].status,"Received");
				p[pos2].qty+=o[pos1].qty;

				int j=0;
				FILE *fp2;
				fp2=fopen("Order.txt","w");		//opens "Order.txt" and change status
				while(j<no_ord)
				{
					fprintf(fp2,"%3d %s %3d %30s %s %s\n",o[j].no,o[j].icode,o[j].qty,o[j].company,o[j].timestamp,o[j].status);
					j++;
				}

				fclose(fp2);
				FILE *fp1;
				fp1=fopen("Product.txt","w");	//update the data in "Product.txt" also
				j=0;	
				while(j<no_prod)
				{
					fprintf(fp1,"%6s %s %s %s %d %.2f \n",p[j].id,p[j].mcat,p[j].brand,p[j].desc,p[j].qty,p[j].mrp);
					j++;
				}
			
				fclose(fp1);
				system("clear");cout<<"\nData successfully updated\n";
				displayinventory();
			}

			else
			{
				system("clear");
				cout<<"\nStatus already Received.Please Check !\n";
				setDisplay();
			}
		}

		else if(option1=="2")
		{
			system("clear");displayinventory();
		}

		else
		{
			goto x3;	
		}
	}
}

void viewStock()		//------------------------Views the stock of the product left 
{	
	cout<<"\n\n";	
	int k=0;
	while(k<no_prod)
	{
		printf("%5s %10s %30s %5d\n",p[k].id,p[k].brand,p[k].desc,p[k].qty);
		k++;
	}

	cout<<"\n\n";
	int countlessthanten=0;
	for(int i=0;i<no_prod;i++)
	{if(p[i].qty<10){cout<<" "<<p[i].id<<",";countlessthanten++;}}
	if(countlessthanten!=0)cout<<"have quantity less than 10";
	cout<<"\n\n";displayinventory();
}

void del_product()		//------------------------Function to delete a product from database
{
	int pos;
	string code,confirm;
	cout<<"\nEnter Item Code : ";
	cin>>code;
        if(ValidateItemCode(code)!=-1)		
	{	cout<<"\nAre you sure you want to delete ?\n";
		check4:cout<<" (Y / N) : ";
		cin>>confirm;
		if(confirm=="y"||confirm=="Y")
		{
			pos=ValidateItemCode(code);
			for(int i=pos;i<no_prod;i++)			//copies next item to the previous one after that product which is to be deleted
			{
				strcpy(p[i].id,p[i+1].id);
				strcpy(p[i].mcat,p[i+1].mcat);
				strcpy(p[i].brand,p[i+1].brand);
				strcpy(p[i].desc,p[i+1].desc);
				p[i].qty=p[i+1].qty;			
				p[i].mrp=p[i+1].mrp;
			}

			no_prod--;
			FILE *fp1;
			fp1=fopen("Product.txt","w+");	
			int j=0;
		
			while(j<no_prod)
			{
				fprintf(fp1,"%s %s %s %s %d %.2f \n",p[j].id,p[j].mcat,p[j].brand,p[j].desc,p[j].qty,p[j].mrp);
				j++;
			}

			fclose(fp1);
			system("clear");		
			cout<<"\n\nData successfully updated\n\n";
			displaymanaging();
		}

		else if(confirm=="n"||confirm=="N")
		{
			setDisplay();
		}

		else
		{
		goto check4;
		}
	
	}
	
	else
	{
		system("clear");
		cout<<"\nProduct does not exist\n";
		setDisplay();
	}	
}

void LoadDiscount()		//------------------------Load the discount 

{
	FILE *fp4;
	fp4=fopen("Discount.bin","rb");
	fscanf(fp4,"%f %f",&discountrate,&margin);
	fclose(fp4);
}

void set_discount()		//------------------------can change the discount scheme
{
	system("clear");
	char enterdiscount[10],entermargin[10];

check2:
	cout<<"\nEnter Discount Rate (in %) :";		//takes the discount rate
	cin>>enterdiscount;
	float entereddiscount = atof(enterdiscount);

	if (entereddiscount<=0 || entereddiscount>=100)
	{
		cout<<"\nEnter a valid Discount Rate";
		goto check2;
	}


	cout<<"\nEnter Margin Price :";		//takes a margin price
check3:cin>>entermargin;
	float enteredmargin=atof(entermargin);
	if (enteredmargin<=0)
	{
		cout<<"\nEnter Valid Margin Price : ";
		goto check3;
	}

	FILE *fp5;				//changes the discount scheme in "Discount.bin"
	fp5=fopen("Discount.bin","wb");
	fprintf(fp5,"%f %f",entereddiscount,enteredmargin);
	fclose(fp5);
	system("clear");
	cout<<"\nDiscountRate and MarginPrice Successfully set\n";
	displaysales(); 
}

int ValidateItemCode(string prod_code)		//-------------------sees if the product exists with the Product ID given as input
{	
	int pos=-1;
	for(int m=0;m<no_prod;m++)
	{
		if(prod_code==p[m].id)
		{
			pos=m;
			break;
		}	
	}

	return pos;
}


void WelcomeScreen()			//-----------------------------set the screen which ask the input as a customer or employee
{
	string number;
	RuntimePrice=0;t=-1;
	system("clear");
	LoadDiscount();
	cout<<"\n\n\t\t\tWELCOME TO OUR SHOP\n\n";     
	if(discountrate!=0)
	{
		cout<<"\n\tToday's offer : "<<discountrate<<"% of discount on or above a purchase of Rs. "<<margin<<endl;
	} 
	checkpoint1:
	cout<<"\n1:Customer\t\t\t2:Employee\t\t\t3:Exit\n";
	cout<<"\n\nPlease Enter Your Option : ";
	cin>>number;
	if(number=="1")
	{
		DisplayCategories();
	}

	if(number=="2")
	{
		password_chk();
	}

	if(number=="3")
	{
		exit(0);
	}

	if(number!="1" || number!="2" || number!="3")
	{
		cout<<"Please Enter a Valid Option\n";
		goto checkpoint1;
	}
}


		    //************************************************MAIN PROGRAM*****************************************//


									int main()
								{

									LoadEmployeeData();
									LoadProductData();
									WelcomeScreen();
									return 0;
												}

